/******************************************************************
*    QuoteTag v2.6beta -- a quote percentage tagline generator    *
*                   written: June 13th 1994 by                    *
*               Kent Hansen (2:230/418.31@FIDONET)                *
*               e-mail:  kent.hansen@scala.pink.dk                *
*                                                                 *
* This script calculates the percentage of quoted characters in a *
* message, and adds a user-specified tagline to the message.      *
*******************************************************************
$VER: QuoteTag 2.6 (13.06.94) (c) 1994 by Kent Hansen
*/

/* Parse the filename */
PARSE ARG file

/******************************************************************
*              Please fill out the five lines below!              *
*           Consult the documentation for instructiuons.          *
******************************************************************/
editor='C:CEd' file '-keepio'
pubscreen='SPOT'
tagpath='REXX:Spot/'
testchanged=1
askadd=1


opts='rt_reqpos=reqpos_centerscr rt_pubscrname='pubscreen
NL='0A'x


/* Check for and load libraries to be used in the script */
IF ~EXISTS('LIBS:rexxreqtools.library') THEN DO
  CALL OPEN('screen','CON:0/0//100/QuoteTagAlert!/CLOSE/SCREEN'pubscreen,'Write')
  WRITELN('screen','Please install the rexxreqtools.library in your LIBS: directory')
  ADDRESS COMMAND('wait 5')
  EXIT
END
CALL ADDLIB('rexxreqtools.library',0,-30,0)

IF ~EXISTS('LIBS:rexxsupport.library') THEN DO
  CALL rtezrequest('Please install the rexxsupport.library in your LIBS: directory')
  EXIT
END
CALL ADDLIB('rexxsupport.library',0,-30,0)


/* Get the time the file was written */
date=SUBWORD(STATEF(file),5,3)

/* Open text editor */
ADDRESS COMMAND(editor)

/* Exit if the date isn't changed */
IF testchanged & date=SUBWORD(STATEF(file),5,3) THEN EXIT


/* Count lines and check for a tagline */
CALL OPEN('infile',file,'READ')
lines=0; tag=0; tagline=""
DO WHILE ~EOF('infile')
  lines=lines+1
  line=READLN('infile')
  IF LEFT(line,4)='... ' THEN tag=lines
  IF tag>0 & line~='' THEN tagline=tagline''line''NL
END
IF tag~=0 THEN lines=tag-1
CALL CLOSE('infile')


/* Make requester */
IF askadd THEN DO
  header = 'QuoteTag v2.5beta  1994 by Kent Hansen'
  IF tag=0 THEN text = 'Do you want a QT-tagline placed in this letter?'
  ELSE text='Replace:'NL tagline'With a QT-tagline?'
  answer = RTEZREQUEST(text,'_Yes|_No',header,opts)
  IF answer=0 THEN EXIT
END

CALL OPEN('outfile','T:QT.tmp','WRITE')
CALL OPEN('infile',file,'READ')

/* Check for quoted and new characters, and copy letter except tagline */
quoted=0; new=0
DO i=1 TO lines
  currentline=READLN('infile')
  IF RIGHT(WORD(currentline,1),1)='>' THEN quoted=quoted+LENGTH(currentline)
  ELSE new=new+LENGTH(currentline)
  CALL WRITELN('outfile',currentline)
END
proc=TRUNC((quoted/(new+quoted))*10000)/100


/* Read the tagline-file */
CALL OPEN('tags',tagpath'quotetag.tags','READ')
tagnumber=1
count=1
DO WHILE ~EOF('tags')
  line=READLN('tags')
  DO WHILE LEFT(line,1)=';' | line=''
    line=READLN('tags')
  END
  arraytags.tagnumber.count=line
  count=count+1
  IF LEFT(WORD(line,1),1)="$" & RIGHT(WORD(line,1),1)="$" THEN DO
    percent=SUBSTR(line,2,LENGTH(line)-2)
    arraypercent.tagnumber=percent
    arraycount.tagnumber=count-2
    tagnumber=tagnumber+1
    count=1
  END
END
CALL CLOSE('tags')


/* Choose the appropriate tagline */
tagnumber=1
DO WHILE arraypercent.tagnumber>proc
  tagnumber=tagnumber+1
END

/* If more than one tagline, pick a random line */
max=arraycount.tagnumber
count=random(1,max,999*trunc(randu(time(s))))
tagline=arraytags.tagnumber.count

/* Insert the percentage in the tagline */
position=POS('$$$',tagline)
IF position>0 THEN DO
  tagline=DELSTR(tagline,position,3)
  tagline=INSERT(proc,tagline,position-1)
END


/* Write new tagline */
CALL WRITECH('outfile','... 'tagline)


/* Cleanup */
CALL CLOSE('infile')
CALL CLOSE('outfile')
CALL DELETE(file)
CALL RENAME('T:QT.tmp', file)

EXIT
