

     Page 1             TrapDoor's Extra Utilities              Page 1

















                              Extra Utilities
                            Copyright (c) 1994
                   Maximilian Hantsch and Martin Laubach
                            All rights reserved






                       Extra Utilities Documentation
                         Friday 27-May-94 12:41:17
                            Copyright (c) 1994
                            Maximilian Hantsch
                            All rights reserved









                 This manual describes the extra utilities
                         which come with TrapDoor.


















     Page 2             TrapDoor's Extra Utilities              Page 2


  1. Introduction     

       This manual is a description of the extra utilities that come
     with TrapDoor, quickly summarizing the usage of each of these
     little goodies.  Please  also  consult  the manuals for TrapDoor
     and TrapList for additional information  on  the nodelist, the
     extra database, and other topics you find missing in here.  

       If you are new to Fidonet, we recommend to read TrapDoor's
     Fidonet Manual (FidoNet.Man) first.  







  2. The Programs     

       The "Extra Utilities" comprise the following utility programs: 

        clearacct    enumnet      enumnodes    getnode
        listacct     listconfig   listnodes    listpasswd
        setconfig    setpasswd    shownl

       All of these programs are little tools that use functions in
     traplist.library to access the Fidonet nodelist and the
     so-called extra database. Using these utilities you can retrieve
     information from the nodelist and extra database, and also
     change some of the information in the extra database.  


























     The Programs


     Page 3             TrapDoor's Extra Utilities              Page 3


  2.1. clearacct     

     Usage: clearacct <nodenumber>
            clearacct ALL

       Clears the TrapDoor accounting information for a single node
     or all systems.  

     Examples: clearacct 2:310/6 
               clearacct all 

  2.2. enumnet     

     Usage: enumnet <nodenumber>

       Shows all nodes and points in the network in which the given
     node resides.  

     Example: enumnet 2:310/3 

  2.3. enumnodes     

     Usage: enumnodes

       Enumerates through all the nodes in the nodelist, printing out
     all zone entries.  

     Example: enumnodes 

  2.4. getnode     

     Usage: getnode <nodenumber>

       Retrieves and displays nodelist information about a single
     node. The output will be something like: 

          Node 2:310/6.0, "The Mad House" is in Vienna Austria
          Operated by Rene Hexel
          Region 31, Hub 0
          Baud 9600
          Phone 603-8532, Cost 0.67
          Flags CM,XW,V32,V42,V42B
          Password secret

     Example: getnode 2:310/6 

  2.5. listacct     

     Usage: listacct

       Displays all accounting information that is stored in the
     extra database. For each node that has accounting information,
     it displays the node number, the total cost of calls since the
     last "clearacct", the number of outgoing calls, the number of


     The Programs                                         listacct


     Page 4             TrapDoor's Extra Utilities              Page 4


     incoming calls, the number of good sessions, the number of
     failed sessions, the number of BUSY, NO CARRIER/NO DIALTONE, and
     the number of VOICE connects.  

       Finally, if the information is available, it will display the
     TrxID of the last session that you had with the remote system.  

     Example: listacct 

       yields: 

        Node         |    Cost   CO  CI   S+  S-    B   N   V
     ----------------+-----------------------------------------
       2:310/6.0     |    0.57    3   0    2   0    1   0   0
                     |       Last session: 2B944A8E/2B944B60
       2:310/90.0    |    2.00    4   0    2   0    2   0   0
                     |       Last session: 2B9449C2/2B944A98

  2.6. listconfig     

     Usage: listconfig

       Shows all the custom configuration entries in the extra
     database. The output will be something like: 

           Node         : Config
          ------------------------
          1:134/2003.0  : Call 001-403-347-3269 ModemDialPre ATS7=90X7DT
          2:205/428.0   : minbaud 2400 noemsi

     Example: listconfig 

  2.7. listnodes     

     Usage: listnodes

       Lists all nodes in the nodelist. The output will be HUGE! 

     Example: listnodes 

  2.8. listpasswd     

     Usage: listpasswd

       Shows all the password entries in the extra database. The
     output will be something like: 

           Node         : Password
          ------------------------
          2:2/5.0       : dont
          2:2/6.0       : even
          2:310/6.0     : think
          2:310/6.1     : about
          2:310/30.0    : it42


     The Programs                                       listpasswd


     Page 5             TrapDoor's Extra Utilities              Page 5


     Example: listpasswd 

  2.9. setconfig     

     Usage: setconfig <nodenumber> "<special config>"
            setconfig <nodenumber> ""
            setconfig <nodenumber>

       Modify and examine individual custom config entries. The first
     form sets a special configuration entry, the second removes it,
     and the third invocation style displays the current setting.  

     Examples: setconfig 2:310/6 "NOEMSI NOWAZOO" 
               setconfig 2:310/6 "" 
               setconfig 2:310/6 

  2.10. setpasswd     

     Usage: setpasswd <nodenumber> "<password>"
            setpasswd <nodenumber> ""
            setpasswd <nodenumber>

       Modify and examine individual session password entries. The
     first form sets a password entry, the second removes it, and the
     third invocation style displays the current password with that
     node.  

     Examples: setpasswd 2:310/6 "magic1" 
               setpasswd 2:310/6 "" 
               setpasswd 2:310/6 

  2.11. shownl     

     Usage: shownl

       Displays the names of all the nodelists that were used to
     compile the current nodelist index file (fidonet.index).  

     Example: shownl 

















     The Programs                                           shownl


     Page 6             TrapDoor's Extra Utilities              Page 6


  3. Politics     

       This chapter describes the software Licence for the extra
     utilities, how they may be distributed, and where you can find
     Support for the programs. Plus, some legalese.  

  3.1. Distribution & Licence     

       These extra utilities are part of TrapDoor. Being part of the
     TrapDoor package, the same software Licence as for TrapDoor
     applies to these extra utilities. They may be distributed freely
     as part of the TrapDoor package: 

       The distributor may only charge a fee up to the costs of
     obtaining a public domain diskette from Fred Fish. The
     distributor agrees to cease distributing the programs and data
     involved if requested to do so by the authors. The distributor
     may only distribute an unmodified copy of the original program,
     with all the supplied documentation and copyright notices
     intact.  

  3.2. Support     

       The latest version of TrapDoor (with all its associated tools)
     is always available for filerequest from FidoNet node 2:310/6,
     "The Mad House" under the magic filename "TRAPDOOR".  

       If you have any suggestions, bug reports etc., feel free to
     contact the authors of TrapDoor at the address given in the
     chapter "Registration" of the TrapDoor manual, or at one of
     these addresses: 

          Maximilian Hantsch      Martin Laubach
          Fido: 2:310/6           Fido: 2:310/3.14
          Uucp: max@madvie.co.at  Uucp: mjl@alison.co.at

       Also, there is a FidoNet Echomail conference called TRAPDOOR,
     which should be available at major backbones. This conference is
     in English and intended for the users of TrapDoor and the extra
     utilities. There, you can freely exchange your experience with
     the software, discuss future enhancements you would like to see
     etc. The authors will participate in the conference and try to
     assist you. The availability of new versions of TrapDoor will be
     announced there, too.  












     Politics                                              Support


     Page 7             TrapDoor's Extra Utilities              Page 7


  3.3. No Warranty    

       THERE IS NO WARRANTY FOR THE PROGRAMS, TO THE EXTENT PERMITTED
     BY APPLICABLE LAW.  EXCEPT WHEN OTHERWISE STATED IN WRITING THE
     COPYRIGHT HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAMS "AS
     IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED,
     INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
     MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE
     ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAMS IS
     WITH YOU.  SHOULD THE PROGRAMS PROVE DEFECTIVE, YOU ASSUME THE
     COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.  

       IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
     WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY
     REDISTRIBUTE THE PROGRAMS AS PERMITTED ABOVE, BE LIABLE TO YOU
     FOR DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR
     CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE
     THE PROGRAMS (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA
     BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD
     PARTIES OR A FAILURE OF THE PROGRAMS TO OPERATE WITH ANY OTHER
     PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED
     OF THE POSSIBILITY OF SUCH DAMAGES.  




  3.4. Disclaimer     

       No warranty, either express or implied, is made with respect
     to the fitness or merchantability of the extra utilities
     described herein.  

       Maximilian Hantsch and Martin Laubach (referred to as "the
     authors"), reserve the right to not develop any future versions
     of these programs.  

       The authors will try to make a good faith attempt at
     correcting any problems if any are discovered, but are in no way
     required, nor bound to correct them.  

       The authors neither assume nor accept any responsibility for
     the use or misuse of these programs. They also will not be held
     liable for damages or any compensation beyond the original
     registration fee due to loss of profit or any other damages
     arising out of the use, or inability to use these programs.  

       Neither Maximilian Hantsch nor Martin Laubach will be liable
     for any damage arising from the failure of these programs to
     perform as described, or any destruction of other programs or
     data residing on a system attempting to run the programs.  While
     we know of no damaging errors, the user of these programs uses
     it at his or her own risk.  




     Politics                                           Disclaimer


     Page 8             TrapDoor's Extra Utilities              Page 8


  4. Acknowledgements     

       The following names are either trademarks or the efforts of
     the person and/or company listed: 

       Amiga and AmigaDOS are trademarks of Commodore-Amiga, Inc.
       ARexx by William S. Hawes, Wishful Thinking Development Corp.
       Fido and FidoNet are trademarks of Tom Jennings, Fido Software.
       Many Thanks to all our beta testers.
       Special Proofreading: Arnout Grootveld.
       Special Thanks to all our Registered Users.
       TrapDoor is a registered trademark of Maximilian Hantsch
                                         and Martin Laubach.
       TrapList, TrapPoll, TrapTell and traplist.library
                      by Maximilian Hantsch and Martin Laubach.
       TrapToss by Ren Hexel.








































     Acknowledgements


     Road Map           TrapDoor's Extra Utilities            paM daoR


  Road Map


        1. Introduction    .....................................    2
        2. The Programs    .....................................    2
           2.1. clearacct    ...................................    3
           2.2. enumnet    .....................................    3
           2.3. enumnodes    ...................................    3
           2.4. getnode    .....................................    3
           2.5. listacct    ....................................    3
           2.6. listconfig    ..................................    4
           2.7. listnodes    ...................................    4
           2.8. listpasswd    ..................................    4
           2.9. setconfig    ...................................    5
           2.10. setpasswd    ..................................    5
           2.11. shownl    .....................................    5
        3. Politics    .........................................    6
           3.1. Distribution & Licence    ......................    6
           3.2. Support    .....................................    6
           3.3. No Warranty   ..................................    7
           3.4. Disclaimer    ..................................    7
        4. Acknowledgements    .................................    8


















              "I think my life needs a rewind/erase button."
              -- "... and a volume control." [Calvin/Hobbes]














     Road Map

