

     Page 1              TrapDoor's Poll Scheduler              Page 1

















                                 TrapPoll
                         TrapDoor's Poll Scheduler
                               Version 1.40
                          Copyright (c) 1990-1994
                   Maximilian Hantsch and Martin Laubach
                            All rights reserved






                             TrapPoll's Manual
                        Saturday 26-Feb-94 14:04:47
                          Copyright (c) 1990-1994
                   Maximilian Hantsch and Martin Laubach
                            All rights reserved









                  This manual is intended to be read from
                    front to back for more convenience.
















     Page 2              TrapDoor's Poll Scheduler              Page 2



  1. Introduction     

       This document is a brief description of TrapPoll, TrapDoor's
     tiny Poll Scheduler, explaining how to set up the software in
     order to have TrapDoor automatically poll all the systems that
     have mail waiting.  

       Please read the entire manual before using TrapPoll.  

       TrapPoll scans your outbound directory, looking for .CLO, .CUT
     and other similar files. It then decides what nodes have mail
     waiting to be delivered and sends messages to a port named
     "TrapDoor" (which happens to be TrapDoor's ARexx port), thus
     telling TrapDoor to make calls to these nodes.  

       In a typical point setup, TrapPoll is not needed. In a node
     environment, TrapPoll will be run every now and then to deliver
     mail.  







  2. Basics     

       TrapPoll is a CLI based application, it can't be run from
     WorkBench. It accepts a few configuration switches that allow an
     easy and accurate configuration. All configuration switches must
     be given on the commandline.  

       On invocation through a standard commandline interface or
     shell, TrapPoll will parse the commandline, look for .?UT and
     .?LO files in your outbound directory, check the proper flavour
     for these files (Crash, Direct, Normal) and decide whether to
     call these nodes. It will then send "CALL node-number" commands
     to TrapDoor's ARexx port, causing TrapDoor to make outgoing
     calls to these nodes. Also, TrapPoll will try to get the result
     string of the call back from TrapDoor and display it. Just try
     it, you will see immediately.  

       Please note that the configuration switches are neither case
     sensitive nor do they have to appear in any specific order.  











     Basics


     Page 3              TrapDoor's Poll Scheduler              Page 3



  3. Configuration Switches    

  3.1. General Configuration    

     -Z zone    

       This is the default zone that TrapPoll should use for
     "old-style" .?LO and .?UT files, i.e. for files with 8-digit hex
     net/nodenumber filenames.  

       Just specify your own zone number here. The default (if no -Z
     switch is specified) is zone 2.  

     -O outbound-dir    

       This is the directory that TrapPoll will scan for outgoing
     files. Set this to your normal outbound directory. The default
     is "MAIL:Outbound/".  

     -P rexx-port-name    

       (new in version 1.23) 

       This is the ARexx portname to which TrapPoll will talk. The
     default is "TrapDoor". If you are running TrapDoor on multiple
     lines, different invocations of TrapDoor will have different
     ARexx-portnames, and you can use this switch to direct TrapPoll
     to call out on a specific line.  

  3.2. Mail Delivery Configuration   

       The following switches can be specified with both a leading
     minus ("-") or plus ("+") sign, meaning "don't call" or "call"
     respectively. The default is to call all nodes with "Crash"
     (also called "Continuous") mail waiting.  

       Note that TrapPoll will never cause nodes with only "Hold"
     mail to be called.  

     +C or -C   

       Tells TrapPoll to call (not call) nodes with "Crash" files
     waiting for them. These files are named .CLO and/or .CUT.  

     +D or -D   

       Tells TrapPoll to call (not call) nodes with "Direct" files
     waiting for them. These files are named .DLO and/or .DUT.  







     Configuration Switches                                 +D or -D


     Page 4              TrapDoor's Poll Scheduler              Page 4


     +N or -N   

       Tells TrapPoll to call (not call) nodes with "Normal" files
     waiting for them. These files are named .FLO and/or .OUT.  

     +R or -R   

       (new in version 1.1) 

       Tells TrapPoll to call (not call) nodes with "Request" files
     waiting for them. These files are named .REQ.  













































     Configuration Switches                                 +R or -R


     Page 5              TrapDoor's Poll Scheduler              Page 5



  4. Examples     

       To call all nodes that have "Crash" mail waiting for them, use 

          TrapPoll -z2 -omail:outbound +C -D -N -R -pTrapDoor 

       Incidentally, the above statement shows you all the default
     settings of TrapPoll. Thus, you could also just type 

          TrapPoll 

       During the FidoNet zone mail hour (ZMH), you might want to
     send mail only to "Direct" mail nodes (because some systems only
     accept FidoNet mail sessions during that time), and not to
     "Crash" nodes (so that your system is free for incoming calls as
     much as possible). In this case, call 

          TrapPoll -C +D +N 

       By now, you certainly got the idea how all this works. If you
     are still not sure, just go ahead and give it a try, you'll
     immediately see how TrapPoll, TrapDoor and your outbound
     directory interact.  




  5. Return Values    

       TrapPoll will almost always return zero (0), except in special
     cases when something has gone wrong. These special cases
     include: incorrect outbound directory specification, disk error
     during directory scan, the path specification for the outbound
     directory is a file and not a directory etc.  

       On these errors, TrapPoll will return 20.  

       If there were no nodes to be called, TrapPoll returns 5.  




  6. Future     

       TrapPoll is just a quick hack to give TrapDoor some scheduling
     capabilities. There really needs to be more work done in that
     field. It would be nice to have one smart "event scheduling"
     program that combines the features of TeaTime, TrapPoll and
     parts of the example "Main" script file. When we find some spare
     time to work on that, we will code it.  





     Future


     Page 6              TrapDoor's Poll Scheduler              Page 6



  7. Politics     

  7.1. Registration     

       TrapPoll is a copyrighted product that has been made available
     to you as part of the TrapDoor project and thus, as Shareware.
     All terms of the license agreement for TrapDoor also are true
     for TrapPoll except as otherwise stated herein. Please consult
     the documentation for TrapDoor for the complete license.  

       If you register TrapDoor, you automatically also gain a
     license to use TrapPoll.  

       Should you decide that you wish to use TrapPoll on its own,
     without registering TrapDoor, a ShareWare registration fee of
     ATS 100,- is suggested. (Though we don't think that TrapPoll
     alone without TrapDoor would be of much use.) By cooperating
     with this concept you help to ensure continued development of
     this product.  

       Site license information for commercial and government use can
     be obtained directly from the authors.  

       No person(s) or businesses other than the authors are
     authorized to accept any registration or distribution fees in
     any form whatsoever. The only people who will be acknowledged as
     registered users are those who have either registered TrapDoor
     or sent ATS 100,- to: 





                           TrapDoor Development
                            Maximilian Hantsch
                      Matzleinsdorfer Platz 3-4/3/10
                                A-1050 Wien
                             Austria / Europe

















     Politics                                         Registration


     Page 7              TrapDoor's Poll Scheduler              Page 7



  7.2. Distribution     

       TrapPoll may be redistributed with two restrictions. First, it
     must be distributed as part of the TrapDoor package. Second, the
     distributor may only charge a fee up to the costs of obtaining a
     public domain diskette from Fred Fish for the complete package.  

       The distributor agrees to cease distributing the programs and
     data involved if requested to do so by the author. The
     distributor may only distribute an unmodified copy of the
     original TrapDoor package, with all the supplied documentation
     and copyright notices intact and without any files being added,
     changed or omitted.  










  7.3. Support     

       If you have any suggestions, bug reports etc., feel free to
     contact the authors of TrapPoll/TrapDoor at the above address.
     Additionally, you can reach us at: 

          Maximilian Hantsch         Martin Laubach
          Fido: 2:310/6              Fido: 2:310/3.14
          Uucp: max@madvie.co.at     Uucp: mjl@alison.co.at

       Also, there is a FidoNet Echomail conference called TRAPDOOR,
     which should be available at major backbones. This conference is
     in English and intended for the users of TrapDoor and, of
     course, TrapPoll as well. There, you can freely exchange your
     experience with these programs, discuss future enhancements you
     would like to see etc. Both authors will participate in the
     conference and try to assist you.  















     Politics                                              Support


     Page 8              TrapDoor's Poll Scheduler              Page 8



  7.4. No Warranty    

       THERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED
     BY APPLICABLE LAW. EXCEPT WHEN OTHERWISE STATED IN WRITING THE
     COPYRIGHT HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM "AS
     IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED,
     INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
     MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE ENTIRE
     RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH
     YOU. SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF
     ALL NECESSARY SERVICING, REPAIR OR CORRECTION.  

       IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
     WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY
     REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU
     FOR DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR
     CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE
     THE PROGRAM (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA
     BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD
     PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER
     PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED
     OF THE POSSIBILITY OF SUCH DAMAGES.  




  7.5. Disclaimer     

       No warranty, either express or implied, is made with respect
     to the fitness or merchantability of TrapPoll.  

       Maximilian Hantsch and Martin Laubach (referred to as "the
     authors"), reserve the right to not develop any future versions
     of TrapPoll.  

       The authors will try to make a good faith attempt at
     correcting any problems if any are discovered, but are in no way
     required, nor bound to correct them.  

       The authors neither assume or accept any responsibility for
     the use or misuse of this program. They also will not be held
     liable for damages or any compensation beyond the original
     registration fee due to loss of profit or any other damages
     arising out of the use, or inability to use this program.  

       Neither Maximilian Hantsch nor Martin Laubach will be liable
     for any damage arising from the failure of this program to
     perform as described, or any destruction of other programs or
     data residing on a system attempting to run the program. While
     we know of no damaging errors, the user of this program uses it
     at his or her own risk.  




     Politics                                           Disclaimer


     Page 9              TrapDoor's Poll Scheduler              Page 9



  8. Acknowledgements     

       The following names are either trademarks or the efforts of
     the person and/or company listed: 

          Amiga and AmigaDOS are trademarks of Commodore-Amiga, Inc.
          Fido and FidoNet are trademarks of Tom Jennings, Fido Software.
          License Agreement inspired by Jack Radigan
                         and the GNU General Public License.
          Many Thanks to our Alpha and Beta testing crew, including,
                         but not limited to:
                         Manfred Schdler, Michael Rck,
                         Michael Schmittner, Peter Wlcek,
                         Ren Hexel, ...
          Special Thanks to all our Registered TrapDoor Users.
          TrapDoor by Maximilian Hantsch and Martin Laubach.
          TrapPoll by Maximilian Hantsch and Martin Laubach.
          TrapList by Martin Laubach and Maximilian Hantsch.





































     Acknowledgements


     Page I              TrapDoor's Poll Scheduler              Page I


  Road Map


        1. Introduction    .....................................    2
        2. Basics    ...........................................    2
        3. Configuration Switches   ............................    3
           3.1. General Configuration   ........................    3
           -Z zone   ...........................................    3
           -O outbound-dir   ...................................    3
           -P rexx-port-name   .................................    3
           3.2. Mail Delivery Configuration  ...................    3
           +C or -C  ...........................................    3
           +D or -D  ...........................................    3
           +N or -N  ...........................................    3
           +R or -R  ...........................................    4
        4. Examples    .........................................    5
        5. Return Values   .....................................    5
        6. Future    ...........................................    5
        7. Politics    .........................................    6
           7.1. Registration    ................................    6
           7.2. Distribution    ................................    7
           7.3. Support    .....................................    7
           7.4. No Warranty   ..................................    8
           7.5. Disclaimer    ..................................    8
        8. Acknowledgements    .................................    9































     Road Map

