
                IMPORT (V 2.4)
                ~~~~~~

Format:   IMPORT <name> <password> [SERVER <server>] [<file>]
~~~~~~~   [GROUP <grouppattern>] [RESTORE] [NOUPDATE]

Template: USER/A,PASSWORD/A,SERVER/K,FILE,GROUP/K,RESTORE/S,NOUPDATE/S
~~~~~~~~~

Purpose:  Import messages to a UMS message-base
~~~~~~~~

Specification:
~~~~~~~~~~~~~~
Files written by EXPORT or UMSDOCTOR can be imported to a UMS message-
base with IMPORT.

For  advantages  of using EXPORT and IMPORT for transportings messages
between   dirrefent   message-bases   and   making   backups  see  the
documentation for EXPORT.

File  created  by  UMSDOCTOR  can  be  imported  to  a (newly created)
message-base, too.


Invocation:
~~~~~~~~~~~
you  must  specify a username and password to log into the (optionally
specified) UMS server that the messages are written to.

If you specify the filename <file>, this will be the file that is read
from.  Otherwise input will be taken from stdin.

The  GROUP  option  allows you to give an AmigaDOS style pattern, that
the  groups  of  imported messages are matched against.  Only messages
with  matching  groups  are  imported,  others are ignored.  Note that
private  messages  have  no  group.  This matches like an empty string
(pattern "%").

When  restoring  from  a  backup  or  a file created by UMSDOCTOR, you
should use the RESTORE keyword. This makes IMPORT behave differently:
 - the Receive-Date will be set to the original one, if possible
 - messages will become "old" to all users
 - access rights will be calculated differently by the umsserver

The  NOUPDATE  option  makes  imported  messages  "new"  even  for the
importing user.


Examples:
~~~~~~~~~

1)
Restore messages after a MB breakdown from a file created by
UMSDOCTOR:

  1> import sysop password Spool:umsdoctor.export restore


2)
Retrieve all groups with substring "UMS" from an archive on tape:

  1) import sysop password btntape:r group "#?ums#?" noupdate


Other examples:  see the documentation for EXPORT


See Also: EXPORT, UMSDOCTOR
~~~~~~~~~
